/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0x90,0

%if 0x90>0

				;Stack cleaning

GLOBAL_LABEL66:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x90

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

					;

	MOV	EAX, 0x1

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4],AL	;$LINK438

	

	PUSH	ESI

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x2a + 0x0]	;cv_setpoint

	MOV	ESI,1	; for ENO management

	CWDE		;INT_2_DINT

	PUSH	EAX

	fnclex			; clear floating point exeption

	FILD	DWORD [ESP]

GLOBAL_LABEL67:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FSTP	DWORD [ESP]

	POP	EAX

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x8 + 0x0],EAX	;Setpoint_temp

	MOV	EAX,ESI

	POP	ESI

[GLOBAL DebugLabel2]

DebugLabel2:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]

	;PhD AND	EAX,0x01	;Start_process

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x8],AL	;$LINK461

	

[GLOBAL DebugLabel3]

DebugLabel3:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x8 + 0x0]	;Setpoint_temp

	MOV	EBX,[@RAT+0x55*8]

	MOV	[EBX + 0x0 + 0x0],EAX	;Setpoint_temp

	

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x34 + 0x0]	;Measured_temp

	MOV	EBX,[@RAT+0x55*8]

	MOV	[EBX + 0x4 + 0x0],AX	;Measured_temp

	

					;

	MOV	AL,[EBP - 0x8]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK461

				;Unlocated unforcable

GLOBAL_LABEL68:

;MOV	EBX,[@RAT+0x55*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x6]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x6],DL	;start

	

	; segundo_postcalled_node

	; clear previous stack usage 0x0

	PUSH DWORD 0x7

				;Stack parameter size =4bytes

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;Heating_control

	MOV	ECX,0x0	;OFF

	MOV	EAX,0x55	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =8bytes

	PUSH	DWORD	EAX

				;Stack parameter size =12bytes

	;DBF_CALL POSTCALLED

[EXTERN Aspfo3$X]

	XOR	EBX,EBX

	MOV	BX,Aspfo3$X

	LEA	EBX,[EBX*8+@RAT]

	CALL	NEAR [EBX]

[GLOBAL DebugLabel4]

DebugLabel4:

	NOP					;For STEP INTO and OVER

				; clean the stack

	ADD	ESP,12

					;

	MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0x7 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_10_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0xc],AL	;$LINK451

	

					;

;MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_5_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x10],AL	;$LINK452

	

					;

;MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0x9 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_1_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x14],AL	;$LINK453

	

					;

;MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0xa + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_1_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x18],AL	;$LINK454

	

					;

;MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0xb + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_5_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x1c],AL	;$LINK455

	

					;

;MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0xc + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_10_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x20],AL	;$LINK456

	

					;

;MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0x7 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_10_percent

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x34d + 0x0],AL	;plus_10_percent

	MOV	[EBP -0x24],EAX

					;

	MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_5_percent

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x351 + 0x0],AL	;plus_5_percent

	MOV	[EBP -0x28],EAX

					;

	MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0x9 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_1_percent

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x350 + 0x0],AL	;plus_1_percent

	MOV	[EBP -0x2c],EAX

					;

	MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0xa + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_1_percent

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x352 + 0x0],AL	;minus_1_percent

	MOV	[EBP -0x30],EAX

					;

	MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0xb + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_5_percent

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x353 + 0x0],AL	;minus_5_percent

	MOV	[EBP -0x34],EAX

					;

	MOV	EBX,[@RAT+0x55*8]

	MOV	AL,[EBX + 0xc + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_10_percent

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x354 + 0x0],AL	;minus_10_percent

	MOV	[EBP -0x38],EAX

[GLOBAL DebugLabel5]

DebugLabel5:

					;

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x350 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_1_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x3c],AL	;$LINK464

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]	;Sec

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x40],EAX

	PUSH	EAX

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x351 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_5_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x44],AL	;$LINK471

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x356]	;Ms_100

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x48],EAX

	POP	ECX

	OR	AL,CL

	

	PUSH	EAX

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x34d + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_10_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4c],AL	;$LINK473

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x357]	;Ms_10

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x50],EAX

	POP	ECX

	OR	AL,CL

	MOV	[EBP -0x54],EAX

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x58],AL	;$LINK445

	

	MOV	AL,[EBP - 0x58]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK445

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$CondLabel1

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x34 + 0x0]	;Measured_temp

	INC	AX

GLOBAL_LABEL69:

	JNO .no_overflow

	INTO				;Signed integer error management

	NOP

	MOV	ESI,0

.no_overflow:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x34 + 0x0],AX	;Measured_temp

	; get the overflow flag

	SETNO AL

[GLOBAL LD_$CondLabel1]

LD_$CondLabel1:

[GLOBAL DebugLabel6]

DebugLabel6:

					;

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x352 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_1_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x5c],AL	;$LINK475

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]	;Sec

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x60],EAX

	PUSH	EAX

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x353 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_5_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x64],AL	;$LINK482

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x356]	;Ms_100

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x68],EAX

	POP	ECX

	OR	AL,CL

	

	PUSH	EAX

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x354 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_10_percent

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x6c],AL	;$LINK484

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x357]	;Ms_10

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x70],EAX

	POP	ECX

	OR	AL,CL

	MOV	[EBP -0x74],EAX

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x78],AL	;$LINK446

	

	MOV	AL,[EBP - 0x78]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK446

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$CondLabel2

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x34 + 0x0]	;Measured_temp

	DEC	AX

GLOBAL_LABEL70:

	JNO .no_overflow

	INTO				;Signed integer error management

	NOP

	MOV	ESI,0

.no_overflow:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x34 + 0x0],AX	;Measured_temp

	; get the overflow flag

	SETNO AL

[GLOBAL LD_$CondLabel2]

LD_$CondLabel2:

[GLOBAL DebugLabel7]

DebugLabel7:

					;

					;

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]

	;PhD AND	EAX,0x01	;Start_process

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x7c],AL	;$LINK486

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x80],AL	;$LINK488

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x34 + 0x0]	;Measured_temp

	CMP	AX,0xc8

	SETLE	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	AND 	AL,0x1

	MOV	[EBP -0x84],EAX

				;Unlocated unforcable

GLOBAL_LABEL71:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x36f]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x36f],DL	;Temp_fault_1

	MOV	[EBP -0x88],EAX

					;

	MOV	AL,[EBP - 0x80]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK488

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x34 + 0x0]	;Measured_temp

	CMP	AX,0x190

	SETGE	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x8c],EAX

				;Unlocated unforcable

GLOBAL_LABEL72:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x371]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x371],DL	;Temp_fault_2

	MOV	[EBP -0x90],EAX

			;SECTION EPIL0G with center child and not a section DFB

	XOR	EAX,EAX; 	Clear accumulator

end_section:

	PUSH	EAX

	; tree for animation link

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x338 + 0x0]

	OR	AX,AX		; Update flags for jump

	JZ	end_animation

	;proto for s_link_anim(	unsigned short sctionvar

  	;			unsigned int BP

	;			unsigned short SS)

	; push the SS segment value 0 in flat mode

	PUSH	DWORD 0x0	;Parameters are on 32bits

					;Stack parameter size =4bytes

	; push the physical stack address

	PUSH 	DWORD EBP

					;Stack parameter size =8bytes

	; here we call the animation service

	PUSH 	DWORD EAX	;Parameters are on 32bits

					;Stack parameter size =12bytes

	XOR	EBX,EBX

	; get the system call number for link animation

					;SYS_CALL

	PUSH	DWORD 0x28

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,4

	CALL	EAX

	ADD	ESP,12

end_animation:

	POP	EAX

[GLOBAL DebugLabel8]

DebugLabel8:

	LEAVE

	RET
